COM_AddCommand("TurnJump", function(player)
	if not (player.shouldturn)
		player.shouldturn = true
		CONS_Printf(player, "Turn Jump ON")
	elseif (player.shouldturn)
		player.shouldturn = false
		CONS_Printf(player, "Turn Jump OFF")
	else
		CONS_Printf(player, "ERROR! Something happened.")
	end
end)

COM_AddCommand("CanThok", function(player)
	if not (player.canthok)
		player.canthok = true
		CONS_Printf(player, "Sonic can thok")
	elseif (player.canthok)
		player.canthok = false
		CONS_Printf(player, "Sonic can't thok")
	else
		CONS_Printf(player, "ERROR! Something happened.")
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "sonic")
			
			//if not (player.atwall)
				player.atwall = 0
			//end
			if not (player.cling)
				player.cling = false
			end
			if not (player.clingprev)
				player.clingprev = false
			end
			if (player.shouldturn == nil)
				player.shouldturn = true
			end
			if (player.canthok == nil)
				player.canthok = true
			end
			
			if (player.mo) //Fixes spectating, and possibly other things
				
				//Finding walls (not FOFs)
				local wall = R_PointInSubsector(player.mo.x+FixedMul(26*FRACUNIT, cos(player.mo.angle)), player.mo.y+FixedMul(26*FRACUNIT, sin(player.mo.angle))).sector
				if (wall.floorheight > player.mo.z) or ((wall.ceilingheight <= player.mo.height+player.mo.z) and not (wall.floorheight == wall.ceilingheight)/* and (wall.ceilingpic == "F_SKY1")*/) //This last bit seems to be broken...
					player.atwall = 1
				end
				//FOFs can be walls too, so lets check for those
				for wall in wall.ffloors()
					
					if (player.mo.z <= wall.topheight) and (player.mo.height+player.mo.z > wall.bottomheight)
						and(wall.flags & FF_BLOCKPLAYER) //Don't want the player to cling to water. That would be stupid
						player.atwall = $1 + 1
					end
					
				end
				
				if(player.atwall <= 0)
					if (player.cling)
						player.pflags = $1&~PF_JUMPED
						player.mo.state = S_PLAY_FALL1
					end
					player.cling = false
				end
				
				if (P_IsObjectOnGround(player.mo))
					player.cling = false
				end
				
				//This allows sonic to thok away from a wall. You can remove this if you dont want your character to do this.
				if (player.canthok)
					if (player.atwall > 0)
						player.charability = CA_NONE
					else
						player.charability = CA_THOK
					end
				else
					player.charability = CA_NONE
				end
				
				//Lazy checks
				if not (player.pflags & PF_NIGHTSMODE)
					and not (player.pflags & PF_ROPEHANG)
					and not (player.pflags & PF_MACESPIN)
					and not (player.pflags & PF_STASIS)
					and not ((player.pflags & PF_THOKKED) and not (player.charability2 == CA2_MULTIABILITY))
					and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
					//If you're clinging to a wall
					if (player.cling)
						and not (player.cmd.buttons & BT_JUMP)
						if (player.mo.eflags == player.mo.eflags & ~MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 20*FRACUNIT)
						else
							P_SetObjectMomZ(player.mo, 12*FRACUNIT)
						end
						S_StartSound(player.mo, sfx_jump)
						player.cling = false
						if (player.charability2 == CA2_SPINDASH)
							player.mo.state = S_PLAY_ATK1 //L
						else
							player.mo.state = S_PLAY_SPRING //P
						end
						player.jumping = false
						P_InstaThrust(player.mo, player.mo.angle, -player.actionspd/3) //Devided by 3 for sonic, but you can remove this for your character
						if (player.shouldturn)
							player.mo.angle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
						end
					end
					
					//Cling onto a wall
					if (player.atwall > 0)
						and (((player.mo.momz < -3*FRACUNIT+1) and not (player.mo.flags2 & MF2_OBJECTFLIP)) or ((player.mo.momz > 3*FRACUNIT-1) and (player.mo.flags2 & MF2_OBJECTFLIP)))
						and (player.pflags & PF_JUMPED)
						and (player.cmd.buttons & BT_JUMP)
						P_SetObjectMomZ(player.mo, -3*FRACUNIT)
						player.mo.momx = $1 / 2
						player.mo.momy = $1 / 2
						player.mo.state = S_PLAY_RUN3 //F
						player.cling = true
						if (player.clingprev == false)
							S_StartSound(player.mo,sfx_s3k4a)
						end
						if not (S_SoundPlaying(player.mo,sfx_s3k7e))
							S_StartSound(player.mo, sfx_s3k7e)
						end
					end
				end
				
				//Movement fix
				if (player.cling)
					player.normalspeed = 0
				else
					player.normalspeed = 35*FRACUNIT
				end
				
				player.clingprev = player.cling
				
			end
					
		end
	end
end)

/*		checkline = line_t
		checksector = sector_t
		rover = ffloor_t
		fofline = false
		side = P_PointOnLineSide(slidemo->x, slidemo->y, li)

		if not (side and li->backsector)
			checksector = li->backsector
		else
			checksector = li->frontsector
		end

		if (checksector->ffloors)
			for (rover = checksector->ffloors; rover; rover = rover->next)
				if (!(rover->flags & FF_EXISTS) || !(rover->flags & FF_BLOCKPLAYER) || (rover->flags & FF_BUSTUP))
					continue

				if (*rover->topheight < slidemo->z)
					continue

				if (*rover->bottomheight > slidemo->z + slidemo->height)
					continue

				// Got this far, so I guess it's clingable
				if (rover.master.flags & ML_TFERLINE)
					size_t linenum = li-checksector->lines[0]
					checkline = rover->master->frontsector->lines[0] + linenum
					fofline = true
				end
			end
		end*/
